'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.observer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var proxy = void 0,
    stateUpdate = void 0,
    handler = {
  set: function set(target, property, value) {
    target[property] = value;
    stateUpdate();
    return true;
  },
  get: function get(target, property) {
    var out = target[property];
    if (out instanceof Object) {
      return new Proxy(out, this);
    }
    return out;
  }
},
    createStore = function createStore(obj) {
  proxy = new Proxy(obj, handler);
  return proxy;
};

var observer = exports.observer = function observer(component) {
  return function (_Component) {
    _inherits(wrapper, _Component);

    function wrapper() {
      _classCallCheck(this, wrapper);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(wrapper).call(this));

      _this.state = proxy;
      return _this;
    }

    _createClass(wrapper, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _this2 = this;

        stateUpdate = function stateUpdate() {
          _this2.setState(proxy);
        };
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(component, this.state);
      }
    }]);

    return wrapper;
  }(_react.Component);
};

exports.default = createStore;