import React, { Component } from 'react';

let proxy, stateUpdate,
    handler = {
    set(target, property, value) {
        target[property] = value;
        stateUpdate();
        return true;
      },
     get(target, property) {
      let out = target[property];
      if (out instanceof Object) {
         return new Proxy(out, this);
      }
      return out;
    }
},
 createStore = (obj) => {
  proxy = new Proxy(obj, handler);
  return proxy;
};

export const observer = (component) => {
 return class wrapper extends Component {
    constructor() {
      super();
      this.state = proxy
    }
    componentWillMount(){
      stateUpdate = () => {
       this.setState(proxy);
      }
    }
    render() {
      return React.createElement(component, this.state );
    }
  }
}

export default createStore;
